2009-05-15  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: if application isn't running on /, make sure we
	generate the correct relative path for the action form attribute.

2009-04-15 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* HtmlInputText.cs: make sure we're inside a Page before dereferencing
	it.

2008-11-06  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: added the undocumented, but supported, Action
	attribute. Fixes bug #442104

2008-10-17  Marek Habersack  <mhabersack@novell.com>

	* HtmlInputHidden.cs: validate the event in LoadPostDataInternal.

	* HtmlInputButton.cs: validate the event in
	RaisePostBackEventInternal ().
	Register for event validation in RenderAttributes ()

	* HtmlTextArea.cs: validate the event in
	RaisePostBackDataChangedEvent ().

	* HtmlButton.cs: validate the event in RaisePostBackEvent ().
	Register for event validation in RenderAttributes ()

	* HtmlAnchor.cs: validate the event in RaisePostBackEvent ().
	Register for event validation in RenderAttributes ().

	* HtmlInputRadioButton.cs, HtmlSelect.cs: validate the event in
	LoadPostData.

	* HtmlInputText.cs, HtmlInputImage.cs, HtmlInputCheckBox.cs,
	HtmlInputPassword.cs: validate the event in
	RaisePostDataChangedEvent ().

2008-10-07  Christian Hergert  <christian.hergert@gmail.com>

	* HtmlImage.cs: Do not render the src attribute if it is null or empty.
	An empty src attribute makes browsers download the current page url as
	the url of the image.

2008-08-29  Marek Habersack  <mhabersack@novell.com>

	* HtmlHead.cs: call base.OnInit ()
	If Page is null, throw an exception.

2008-07-25  Dean Brettle <dean@brettle.com>

	* HtmlControl.cs (PreProcessRelativeReference), 
	HtmlForm.cs (RenderAttributes), HtmlInputButton (RenderAttributes),
	HtmlInputRadioButton (RenderAttributes), HtmlSelect (RenderChildren):
	Encode attributes that could contain HTML special chars.
	
	* HtmlSelect (RenderChildren): HTML-encode option text.

2008-06-30  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: hush the warnings

2008-06-08  Gert Driesen  <drieseng@users.sourceforge.net>

	* HtmlAnchor.cs: Do not render empty name, target or title attribute.
	Removed extra check for target attribute in RenderAttributes. Use
	string.Empty instead of "", and check string's Length instead of
	comparison with "" or string.Empty. Minor code formatting.

2008-06-04  Juraj Skripksy  <js@hotfeet.ch>

	* HtmlAnchor.cs (Render): Add missing call to
	ClientScriptManager.RegisterForEventValidation. Fixes bug #397142.

2008-06-04  Juraj Skripsky  <js@hotfeet.ch>

	* HtmlAnchor.cs: Do not render an empty href attribute.
	Fixes bug #397046.

2008-02-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlForm.cs: fixed action attribute in RenderAttributes under
	TARGET_JVM

2008-02-06  Marek Habersack  <mhabersack@novell.com>

	* HtmlMeta.cs: render XHTML compliant tag if not in the Legacy
	mode. Fixes bug #354425

2008-01-17 Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlSelect.cs: refactoring. 

2008-01-17 Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlSelect.cs: fix databinding (only 2.0), state management. 

2008-01-14  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlSelect.cs: Fix infinite recursion (only in 2.0) found using 
	Gendarme.

2007-01-07 Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlForm.cs: refactoring.

2007-12-13  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs, HtmlButton.cs: speed optimization - use String.Concat
	instead of String.Format in some cases.

2007-11-07  Juraj Skripsky  <js@hotfeet.ch>

	* HtmlForm.cs (RenderAttributes): Render ClientID of DefaultButton.
	Fixes bug #339426 for master pages.

2007-11-06  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: a small DetermineRenderUplevel optimization - the
	result is now cached in a nullable boolean variable.
	Render the 'onkeypress' attribute if DefaultButton is used. Fixes
	bug #339426.

2007-08-27  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: make sure the ID is set before HtmlControls renders
	the attributes. Fixes bug #82596

2007-08-05  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlHead.cs: refactoring, used AddAttribute overload without encoding
	on known attribute values

2007-07-31  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlControl.cs: fixed PreProcessRelativeReference, should be used
	ResolveClientUrl

2007-07-16  Marek Habersack  <mhabersack@novell.com>

	* HtmlHeadBuilder.cs: the <meta> tag should be supported as well.

	* HtmlTitle.cs: if the tag has any children, or the render method
	delegate has been defined, render the children. Output the
	contents of Text otherwise. Fixes bug #82102

2007-05-08  Marek Habersack  <mhabersack@novell.com>

	* HtmlInputButton.cs: button of type 'reset' does not invoke
	OnServerClick event.
	'reset' buttons clear all the controls in the form to their
	default values.

2007-05-04  Marek Habersack  <mhabersack@novell.com>

	* HtmlAnchor.cs: use ResolveClientUrl when generating
	attributes. Necessary if the control is in a master page which is
	in a different directory than the current page.

2007-05-01  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: do not use User-Agent directly, we must take
	ClientTarget into account.

2007-04-27  Marek Habersack  <mhabersack@novell.com>

	* HtmlHeadBuilder.cs: support <link> tags - we need to map virtual
	paths that might happen in them.

2007-04-18  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlForm.cs: for TARGET_J2EE: 
	used Page.Request.Browser to determine RenderUplevel

2007-04-17  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: use the new uplevel browser detection code.

2007-04-11  Marek Habersack  <mhabersack@novell.com>

	* HtmlInputHidden.cs:
	* HtmlSelect.cs:
	* HtmlInputText.cs:
	* HtmlSelect.cs:
	* HtmlInputText.cs:
	* HtmlInputImage.cs:
	* HtmlInputFile.cs:
	* HtmlInputCheckBox.cs:
	* HtmlInputRadioButton.cs:
	* HtmlInputImage.cs: do not register the control for post back
	processing or if it's disabled.

2007-04-06  Marek Habersack  <mhabersack@novell.com>

	* HtmlForm.cs: render the 'name' attribute only when in non-xhtml
	compliant mode.

2007-02-19  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlInputCheckBox.cs:
	* HtmlInputControl.cs:
	* HtmlInputHidden.cs:
	* HtmlInputRadioButton.cs:
	* HtmlInputText.cs:
	* HtmlSelect.cs:
	* HtmlTextArea.cs:
	fixed: Form.SubmitDisabledControls feature:	
	not all HtmlInputControl need to be reenabled on client.		  

2007-02-18  Eyal Alaluf <eyala@mainsoft.com>

	* HtmlForm.cs: Under TARGET_J2EE use Page.RenderResponse instead of
	  GetRenderResponse.

2007-01-20  Miguel de Icaza  <miguel@novell.com>

	* HtmlHead.cs: comment out unused code, in particular metadata is
	commented out because nothing could have triggered its creation.

	* HtmlButton.cs: Move declaration of `csm' inside the 1.1 case.

2007-01-16  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlLink.cs: fixed RenderAttributes, href should be resolved

2007-01-14  Eyal Alaluf  <eyala@mainsoft.com>

	* HtmlForm.cs, HtmlAnchor.cs: Added J2EE Portal support for TARGET_J2EE.

2007-01-14  Eyal Alaluf  <eyala@mainsoft.com>

	* HtmlInputImage.cs: to handle correctly relative URLs to the image.

2007-01-07  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlInputRadioButton.cs: fixed: LoadPostData.		  

2007-01-07  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlImputImage.cs: fixed: OnServerClick.		  

2006-12-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: ignore user provided 'onsubmit' for HtmlForm. See
	bug #76974.

2006-11-27  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlForm.cs: refactoring: Registering of client scripts
	moved to Page.		  

2006-11-17  Marek Habersack  <grendello@gmail.com>

	* HtmlInputHidden.cs: Added support for event validation.

	* HtmlInputCheckBox.cs: Added support for event validation.

	* HtmlInputImage.cs: Added support for event validation.

	* HtmlInputButton.cs: Added support for event validation.

	* HtmlSelect.cs: Added support for event validation.

	* HtmlTextArea.cs: Added support for event validation.

	* HtmlButton.cs: Added support for event validation.

	* HtmlInputRadioButton.cs: Added support for event validation.

	* HtmlInputText.cs: Added support for event validation.

2006-11-13  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlContainerControl.cs: fixed: InnerHtml property  

2006-09-18  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlHead.cs: 
	HtmlTitle control is created if it was not declared in .aspx	

2006-09-17  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlButton.cs: 
	make rendering of the onclick attribute to consider ValidationGroup property	

2006-09-17  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlInputImage.cs: 
	make rendering of the onclick attribute to consider ValidationGroup property	

2006-09-17  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlInputButton.cs: 
	make rendering of the onclick attribute to consider ValidationGroup property	

2006-09-17  Igor Zelmanovich  <igorz@mainsoft.com>

	* HtmlAnchor.cs: 
	implemented CausesValidation and ValidationGroup properties	

2006-09-10  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlInputFile.cs: fixed Value property

2006-08-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTextArea.cs: encode the value in 1.x too. Patch by Dean Brettle.

2006-08-08  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlTable.cs:
	* HtmlTableRow.cs: fixed ParseChildren attribute to be compliant
	to .net

2006-07-12 Andrew Skiba <andrews@mainsoft.com>

	* HtmlInputControl.cs: remove obsolete #if NET_2_0

2006-06-06 Juraj Skripsky <js@hotfeet.ch>

	* HtmlForm.cs (RenderAttributes): Sync with changes to HttpRequest.
	Fixes bug #78591.

2006-04-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTextArea.cs: Value is HtmlEncoded/Decoded in 2.0. Fixes
	bug #78074.

2006-04-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputRadioButton.cs: Value returns the ID only when there's no
	"value" set. Fixes bug #78101.

2006-03-19  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HtmlAnchor.cs: fixed RenderAttributes, if target attribute is empty 
	it shouldn't be rendered
	* HtmlForm.cs: fixed Method, default method "post" should be added if 
	its value null or empty string
	* HtmlInputImage.cs: fixed SetAtt, it removes attributes if it has null 
	value, the fix is to remove attributes with empty string value too

2006-02-23  Chris Toshok  <toshok@ximian.com>

	* HtmlButton.cs: fix corcompare output.

	* HtmlInputButton.cs: same.

	* HtmlInputImage.cs: same.

	* HtmlInputReset.cs: same.

2006-01-22  Chris Toshok  <toshok@ximian.com>

	* HtmlInputButton.cs:
	s/GetPostBackClientEvent/GetPostBackEventReference.

2005-12-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTableRow.cs: Cells is virtual in latest 1.1.

2005-11-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTableRow.cs: fixed the same problem in bug #76815 but this time
	for cells.
	* HtmlTable.cs: moved WriteLine around.

2005-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: more class-status fixes.

2005-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTextArea.cs: 'Name' is the UniqueID. Fixes bug #76802.

2005-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTable.cs: use the base class RenderChildren, as '_rows'
	might not be the actual collection being used. Fixes bug #76815.

2005-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputFile.cs: if no one else set the encoding type for the
	containing form and there's a HtmlInputFile, set Enctype to
	'multipart/form-data'. Fixes bug #76837.

2005-11-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputButton.cs: render the onclick attribute only when the
	button is a 'submit' and no validators or when the button is a
	'button' and there's a registered ServerClick event. Fixes bug #76781.

2005-09-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: register the form and require viewstate hidden field to
	be rendered in Render() even if OnInit is not called.

2005-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlHead.cs: fix the 2.0 build.

2005-09-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: when transfering from one page to another and using
	cookieless session, we were doing pretty bad. Now, if the current path
	and the original are the same, we just use the filename. Otherwise
	we make the action location be relative to the original URL.

2005-09-19 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputButton.cs: render the onclick for doing a postback even when
	there are no validators.

2005-09-19  Sebastien Pouliot  <sebastien@ximian.com> 

	* HtmlInputPassword.cs: Removed ctor(string) as it's not in 2.0 RC.
	
2005-09-19  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlAnchor.cs: Added [SupportsEventValidation] on class and 
	[UrlProperty] on HRef property for 2.0.
	* HtmlButton.cs: Added [SupportsEventValidation] for 2.0.
	* HtmlHead.cs: Remove IPageHeader interface.
	* HtmlImage.cs: Added [UrlProperty] on Src property for 2.0.
	* HtmlInputButton.cs: Added [SupportsEventValidation] for 2.0.
	* HtmlInputCheckBox.cs: Added [SupportsEventValidation] for 2.0.
	* HtmlInputHidden.cs: Added [SupportsEventValidation] for 2.0.
	* HtmlInputImage.cs: Added [SupportsEventValidation] on class and 
	[UrlProperty] on Src property for 2.0.
	* HtmlInputPassword.cs: Added [SupportsEventValidation].
	* HtmlInputRadioButton.cs: Added [SupportsEventValidation] for 2.0.
	* HtmlInputReset.cs: Added [SupportsEventValidation].
	* HtmlInputSubmit.cs: Added [SupportsEventValidation].
	* HtmlInputText.cs: Added [SupportsEventValidation] on class and 
	re-enabled RenderAttribute for 2.0.
	* HtmlLink.cs: Added [UrlProperty] on HRef property for 2.0.
	* HtmlSelect.cs: Added [SupportsEventValidation] for 2.0.
	* HtmlTextArea.cs: Added [SupportsEventValidation] for 2.0.

2005-09-18  Chris Toshok  <toshok@ximian.com>

	* HtmlButton.cs (RenderAttribute): make sure to use WriteAttribute
	instead of AddAttribute when dealing with "onclick."

2005-09-14  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlHead.cs: Fixed parameter orders for CreateStyleRule.

2005-09-11  Chris Toshok  <toshok@ximian.com>

	* HtmlInputFile.cs (set_Value): add a message to the
	NotSupportedException.

	* HtmlInputControl.cs (RenderAttributes): add Page != null to the
	checks before we register our control with the
	__enabledControlArray JS array.

2005-09-09  Chris Toshok  <toshok@ximian.com>

	* HtmlInputButton.cs (CausesValidation): this is stored in
	Attributes, not ViewState.
	(ValidationGroup): same.
	(RenderAttributes): remove CausesValidation from the list of
	Attributes before calling base.RenderAttributes.  Don't, however,
	remove ValidationGroup, to replicate an MS bug.

2005-09-07  Chris Toshok  <toshok@ximian.com>

	* HtmlForm.cs (DefaultFocus): not stored in Attributes either.
	(Name): not sure about this property.. the getter apparently just
	returns UniqueID, and the setter does nothing that I can figure
	out.
	(RenderAttributes): don't bother to remove "name", since it's not
	in the attributes anyway.

2005-09-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputControl.cs: use the Name property instead of the ClientID.
	The 'name' attribute rendered contains colons if inside a
	NamingContainer.

2005-09-07  Chris Toshok  <toshok@ximian.com>

	* HtmlInputCheckBox.cs (Checked): uncomment the
	MinimizableAttributeTypeConverter attribute.

	* HtmlControl.cs (Disabled): uncomment the
	MinimizableAttributeTypeConverter attribute.

	* HtmlForm.cs (SubmitDisabledControls): remove the MonoTODO.

	* HtmlTableCell.cs (NoWrap): uncomment the
	MinimizableAttributeTypeConverter attribute.

	* HtmlLink.cs (Href): remove the MonoTODO.

	* HtmlMeta.cs (Name): remove the MonoTODO.
	(Scheme): same.
	(Render): add (pretty bogus, really..) implementation.  not sure
	why we need this one.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* HtmlInputControl.cs (RenderAttributes): Check Page.Form for
	null.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* HtmlInputControl.cs (RenderAttributes): use ClientID instead of
	ID.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* HtmlHead.cs (AddParsedSubObject): nuke, not in corcompare.
	(AddedControl): move the HtmlTitle logic here.
	(RemovedControl): clear out the title if that was the control that
	was removed.

	* HtmlLink.cs: new implementation.

	* HtmlMeta.cs: new implementation.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* HtmlInputControl.cs (RenderAttributes): add ourselves to the
	__enabledControlArray JS array if we're currently enabled and the
	form is set to SubmitDisabledControls.

	* HtmlForm.cs (OnInit): call Page.RegisterForm here.
	(DetermineRenderUplevel): split this out of OnPreRender and make
	it internal so HtmlInputControl can call it.
	(OnPreRender): add handling for SubmitDisabledControls.

2005-09-05  Chris Toshok  <toshok@ximian.com>

	* HtmlForm.cs (DefaultButton): this isn't stored as an Attribute,
	or in the ViewState.  where then?
	(DefaultFocus): this one is stored in the ViewState, not as an
	Attribute.
	(SubmitDisabledControls): implement just as a boolean flag, not in
	the viewstate or attributes.
	(RenderAttributes): defaultfocus and defaultbutton are no longer
	in Attributes.

2005-09-04  Chris Toshok  <toshok@ximian.com>

	* HtmlInputButton: Fix the 2.0/1.0 postback stuff the right way.
	
	* HtmlInputCheckBox: Fix the 2.0/1.0 postback stuff the right way.
	
	* HtmlInputFile.cs: Fix the 2.0/1.0 postback stuff the right way.

	* HtmlInputHidden.cs: Fix the 2.0/1.0 postback stuff the right
	way, and in OnPreRender, call Page.RegisterRequiresPostback.

	* HtmlInputImage.cs: Fix the 2.0/1.0 postback stuff the right way,
	and in OnPreRender, call Page.RegisterRequiresPostback.

	* HtmlInputRadioButton.cs (OnPreRender): call
	Page.RegisterRequiresPostback.
	
	* HtmlInputText.cs: Fix the 2.0/1.0 postback stuff the right way.
	Also, in OnPreRender, call Page.RegisterRequiresPostback.

	* HtmlTextArea.cs (OnPreRender): call
	Page.RegisterRequiresPostback.

2005-09-02  Chris Toshok  <toshok@ximian.com>

	* HtmlSelect.cs: implement 2.0 DataSourceID data binding.

2005-09-02  Chris Toshok  <toshok@ximian.com>

	* HtmlInputReset.cs (ValidationGroup): remove the MonoTODO.

	* htmlinputimage.cs: implement the 2.0 versions of loadpostdata,
	raisepostdatachangedevent, and raisepostbackevent.
	(validationgroup): implement.

	* htmlinputcheckbox.cs: implement the 2.0 versions of loadpostdata
	and raisepostdatachangedevent.

	* HtmlInputHidden.cs: implement the 2.0 versions of LoadPostData
	and RaisePostDataChangedEvent.

	* HtmlInputButton.cs (RaisePostBackEventInternal): split out the
	body of both RaisePostBackEvent impl's here, and fix it up so we
	use the property Page.Validate call in 2.0.
	(RaisePostBackEvent): call RaisePostBackEventInternal.
	(IPostBackEventHandler.RaisePostBackEvent): same.

	* HtmlImage.cs (Align): the test case shows that we don't need to
	validate input.

2005-09-01  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlTableCell.cs, HtmlTableRowCollection.cs, HtmlInputFile.cs,
	HtmlHead.cs, HtmlInputReset.cs, HtmlForm.cs, HtmlInputText.cs,
	HtmlHeadBuilder.cs, HtmlInputRadioButton.cs, HtmlAnchor.cs,
	HtmlButton.cs, HtmlTextArea.cs, HtmlGenericControl.cs, 
	HtmlTableRow.cs, HtmlSelect.cs, HtmlControl.cs, HtmlImage.cs,
	HtmlSelectBuilder.cs, HtmlTable.cs, HtmlInputButton.cs,
	HtmlInputImage.cs, HtmlTableCellCollection.cs, HtmlInputCheckBox.cs,
	HtmlInputHidden.cs, HtmlTitle.cs, HtmlInputPassword.cs, 
	HtmlContainerControl.cs, HtmlInputSubmit.cs: Add missing security
	attributes AspNetHostingPermission for Minimal level on all classes
	(LinkDemand) and for non-sealed classes (InheritanceDemand).

2005-08-29  Chris Toshok  <toshok@ximian.com>

	* System.Web.UI.HtmlControls/HtmlTableCell.cs,
	System.Web.UI.HtmlControls/HtmlInputFile.cs,
	System.Web.UI.HtmlControls/HtmlForm.cs,
	System.Web.UI.HtmlControls/HtmlInputText.cs,
	System.Web.UI.HtmlControls/HtmlInputRadioButton.cs,
	System.Web.UI.HtmlControls/HtmlAnchor.cs,
	System.Web.UI.HtmlControls/HtmlButton.cs,
	System.Web.UI.HtmlControls/HtmlTextArea.cs,
	System.Web.UI.HtmlControls/HtmlGenericControl.cs,
	System.Web.UI.HtmlControls/HtmlSelect.cs,
	System.Web.UI.HtmlControls/HtmlTableRow.cs,
	System.Web.UI.HtmlControls/HtmlControl.cs,
	System.Web.UI.HtmlControls/HtmlImage.cs,
	System.Web.UI.HtmlControls/HtmlTable.cs,
	System.Web.UI.HtmlControls/HtmlInputButton.cs,
	System.Web.UI.HtmlControls/HtmlInputControl.cs,
	System.Web.UI.HtmlControls/HtmlInputImage.cs,
	System.Web.UI.HtmlControls/HtmlInputCheckBox.cs,
	System.Web.UI.HtmlControls/HtmlInputHidden.cs,
	System.Web.UI/Control.cs: Add WebSysDescription/WebCategory
	attributes.

2005-08-29  Chris Toshok  <toshok@ximian.com>

	* HtmlInputSubmit.cs: new implementation.
	
	* HtmlInputReset.cs (ValidationGroup): implement

	* HtmlInputButton.cs (ValidationGroup): implement.

2005-08-29  Chris Toshok  <toshok@ximian.com>

	* HtmlButton.cs: Fix some 2.0 Page/ClientScript obsolete warnings.

	* HtmlForm.cs: same.

2005-08-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlAnchor.cs: no need for the resolvedHRef field, as it might be set
	but not used.  Call ResolveUrl when rendering the attributes instead.

2005-08-28  Chris Toshok  <toshok@ximian.com>

	* HtmlHeadBuilder.cs: this is public.

	* HtmlSelectBuilder.cs: in 2.0 this is public.

	* HtmlInputButton.cs: fix boilerplate.

	* HtmlInputImage.cs (RaisePostBackEvent): add missing argument.
	(IPostBackEventHandler.RaisePostBackEvent): in 2.0, call
	Page.Validation(ValidationGroup).

2005-08-28  Chris Toshok  <toshok@ximian.com>

	* HtmlInputReset.cs: mostly complete implementation.

2005-08-28  Chris Toshok  <toshok@ximian.com>

	* HtmlInputPassword.cs: doh, make this NET_2_0 only.

2005-08-28  Chris Toshok  <toshok@ximian.com>

	* HtmlInputPassword.cs: implement.

2005-08-28  Chris Toshok  <toshok@ximian.com>

	* HtmlImage.cs: corcompare fixes.

	* HtmlInputCheckBox.cs: same.

2005-08-27  Chris Toshok  <toshok@ximian.com>

	* HtmlControl.cs (GetAttribute, SetAttribute): implement.

2005-08-27  Chris Toshok  <toshok@ximian.com>

	* HtmlForm.cs (DefaultButton, DefaultFocus): implement properties.
	(OnPreRender): figure out (hackishly) if we're uplevel rendering.
	If we have a default button/focus control set, register webform.js
	as a client script block, and emit some JS to focus the control.
	(RenderAttributes): verify that the DefaultButton attribute points
	to a valid IButtonControl implementing control.  Also remove the
	defaultfocus/defaultbutton attributes before calling
	base.RenderAttributes.

2005-08-27  Kornél Pál  <kornelpal@hotmail.com>

	* HtmlTableCell.cs: Fixed to use Consts.

2005-08-26  Chris Toshok  <toshok@ximian.com>

	* HtmlButton.cs (ValidationGroup): implement.
	(RaisePostBackEvent): gross #ifdef-iry to make sure we only have
	one body of the actual RaisePostBackEvent code.  Also, call
	Page.Validate(ValidationGroup) in the 2.0 case.

2005-08-25  Miguel de Icaza  <miguel@novell.com>

	* HtmlHead.cs: Implement constructor, pass the tag.

2005-08-25  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlHead.cs: Fixed base class (to HtmlGenericControl).

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* HtmlForm.cs (CreateControlCollection, OnPreRender,
	RenderControl): implement naively, just calling base.Method.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* HtmlForm.cs (RenderAttributes): don't strip off the stuff after
	the last '/' when rendering the action.  Fixes comments in
	nGallery.

2005-08-24  Chris Toshok  <toshok@ximian.com>

	* HtmlInputButton.cs, HtmlInputFile.cs, HtmlHead.cs,
	HtmlInputImage.cs, HtmlForm.cs, HtmlInputCheckBox.cs,
	HtmlInputHidden.cs, HtmlButton.cs, HtmlSelect.cs, HtmlControl.cs:
	Add MonoTODO's for all NotImplementedException's.

2005-08-18  Dick Porter  <dick@ximian.com>

	* HtmlTable.cs, HtmlInputButton.cs, HtmlInputFile.cs, HtmlHead.cs,
	HtmlInputImage.cs, HtmlForm.cs, HtmlInputText.cs,
	HtmlInputCheckBox.cs, HtmlAnchor.cs, HtmlInputRadioButton.cs,
	HtmlButton.cs, HtmlInputHidden.cs, HtmlTextArea.cs,
	HtmlTableRow.cs, HtmlSelect.cs, HtmlControl.cs, HtmlTitle.cs,
	HtmlContainerControl.cs: 2.0 API fixes and stubs and attribute fixes

2005-08-15  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlInputRadioButton.cs, HtmlInputText.cs, HtmlTextArea.cs: Renamed 
	Load method (bad choice) to DefaultLoadPostData.

2005-08-15  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* HtmlAnchor.cs: Fixed protected RaisePostBackEvent in 2.0.
	* HtmlInputRadioButton.cs: Fixed Value property and LoadPostData 
	method. Fixed support for protected LoadPostData and 
	RaisePostDataChangedEvent in 2.0 (recursion).
	* HtmlInputText.cs: Fixed LoadPostData. Fixed support for protected
	LoadPostData and RaisePostDataChangedEvent in 2.0 (recursion).
	* HtmlTextArea.cs: Fixed LoadPostData. Fixed support for protected
	LoadPostData and RaisePostDataChangedEvent in 2.0 (recursion).

2005-08-15  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlTableCell.cs: Added "string" [TypeConverter] attribute to NoWrap 
	for 2.0	profile. The class seems to be internal and not (yet?) 
	implemented.

2005-08-13  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlAnchor.cs: Add Localizable attribute to 2.0 profile.
	* HtmlEmptyTagControlBuilder.cs: New. ControlBuilder required for
	(at least) HtmlInputControl in 2.0 profile.
	* HtmlInputControl.cs: Use a new ControlBuilder class for 2.0 profile.
	* HtmlInputText.cs: Fix DefaultValue attribute for 2.0 profile.

2005-08-09  Dick Porter  <dick@ximian.com>

	* HtmlSelect.cs: Clear databindings when adding a new one; cope
	with assorted combinations of empty text and value fields; write
	<option> tags manually to match ms HTML output.  All fix nunit
	tests.

2005-08-08  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlInputControl.cs: Remove code to handle password (wrong place) 
	and fixed type handling for 2.0.
	* HtmlInputText.cs: Added code to remove (only in 1.x) the value when
	the type == password. Tests indicates that the value is present for 
	2.0.

2005-08-05  Dick Porter  <dick@ximian.com>

	* HtmlSelect.cs: Fix databinding when one or other of Name and
	Value aren't supplied (thanks to Peter for the patch); Make
	<option> indenting match ms output.

2005-07-30  Ben Maurer  <bmaurer@ximian.com>

	* HtmlForm.cs: Make sure we actually put the "?" in the url

2005-07-29  Dick Porter  <dick@ximian.com>

	* HtmlForm.cs: Simplify the rendering code by using QueryStringRaw
	instead of building the query string by hand

2005-07-27  Dick Porter  <dick@ximian.com>

	* HtmlInputCheckBox.cs: New implementation

2005-07-26  Peter Dennis Bartok  <pbartok@novell.com>

	* HtmlSelect.cs: Added missing attributes

2005-07-26  Dick Porter  <dick@ximian.com>

	* HtmlSelect.cs: New implementation

2005-07-26  Miguel de Icaza  <miguel@novell.com>

	* HtmlForm.cs: It is possible to have keys with no values in the
	query string, do not try to process those on the foreach loop.
	
	The question is: what should happen if I only get the key?

	Example: file_with_a_form.aspx?a

2005-07-25  Peter Dennis Bartok  <pbartok@novell.com>

	* HtmlForml.cs: Implemented UniqueID (new in sp1)
	* HtmlButton.cs, HtmlInputButton.cs, HtmlInputImage.cs: Attribute fixes

2005-07-24  Dick Porter  <dick@ximian.com>

	* HtmlForm.cs: Add the trailing query string to the form action;
	fixes bug shown in Test/standalone/htmlform/qs_postback.aspx

2005-07-22  Dick Porter  <dick@ximian.com>

	* HtmlInputFile.cs: Add assembly attributes

2005-07-21  Dick Porter  <dick@ximian.com>

	* HtmlImage.cs: The src attribute needs to be a relative URL;
	close the HTML element when rendering attributes, to match the MS
	impl.

	* HtmlForm.cs: Added assembly attributes; don't render ID twice;
	don't render enctype and target if they are empty strings;
	implement a Render overload to keep corcompare quiet.

2005-07-20  Chris Toshok  <toshok@ximian.com>

	* HtmlForm.cs (RenderAttributes): if there are submit statements,
	we need to render those.

	* HtmlInputImage.cs: same.

	* HtmlInputButton.cs: hook up the client validation stuff.

	* HtmlButton.cs: same, except a lot more complicated due to
	postback handling.

2005-07-19  Dick Porter  <dick@ximian.com>

	* HtmlImage.cs: Added attributes; use Int32.Parse instead of
	Convert.ToInt32

2005-07-18  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* HtmlInputControl.cs: Fix Type when using ctor(null). Now use 
	ControlID for Name (and not ID). Added ControlBuilder attribute.
	* HtmlTable.cs: Simplify check when adding controls.
	* HtmlTableRow.cs: Simplify check when adding controls.

2005-07-18  Jackson Harper  <jackson@ximian.com>

	* HtmlInputHidden.cs: Use Events Add/Remove. Add DefaultEvent
	attribute.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* HtmlInputImage.cs: Use Events Add/Remove. Remove uneeded
	constant. Update fetching from viewstate code to use new
	convenience method.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* HtmlInputButton.cs: Add DefaultEventAttribute.

2005-07-15  Sebastien Pouliot  <sebastien@ximian.com>
 
	* HtmlInputControl.cs: Removed internal property (no more required to 
	compile).
	* HtmlInputRadioButton.cs: Optimized events.
	* HtmlInputText.cs: Optimized events.
	* HtmlTable.cs: Added CultureInfo.InvariantCulture when parsing 
	strings to integers.
	* HtmlTableCell.cs: Added CultureInfo.InvariantCulture when parsing 
	strings to integers.
	* HtmlTextArea.cs: Optimized events.

2005-07-15  Sebastien Pouliot  <sebastien@ximian.com> 

	* HtmlAnchor.cs: Added URL resolution (doesn't get me the expected 
	result) and fixed compatibility for a weird behaviour of the HRef 
	attribute handling. Optimized events.

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* HtmlInputButton.cs: Use Events Add/Remove. Remove Causesvalidation
	string constant. Use new method for accessing ViewState
	data. Don't remove value from the view state if it is the default.

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* HtmlButton.cs: Use Events Add/Remove. Remove Causesvalidation
	string constant. Use new method for accessing ViewState
	data. Don't remove value from the view state if it is the default.
	
2005-07-14  Dick Porter  <dick@ximian.com>

	* HtmlInputFile.cs: New implementation

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* HtmlInputControl.cs: Use ClientID for input controls name.

2005-07-14  Dick Porter  <dick@ximian.com>

	* HtmlForm.cs: New Implementation

2005-07-13  Sebastien Pouliot  <sebastien@ximian.com> 

	* HtmlTable.cs: Added missing attributes.
	* HtmlTableCell.cs: Added missing attributes except for ControlBuilder
	as the builder's type isn't public.
	* HtmlInputControl.cs: Added missing attributes.
	* HtmlInputText.cs: Added missing attributes.
	* HtmlInputRadioButton.cs: Added missing attributes.
	* HtmlAnchor.cs: Added missing attributes.
	* HtmlTextArea.cs: Added missing attributes.
	* HtmlTableRow.cs: Added missing attributes.

2005-07-12  Sebastien Pouliot  <sebastien@ximian.com> 

	* HtmlAnchor.cs: Added DefaultValue attributes.
	* HtmlInputControl.cs: Added DefaultValue attributes.
	* HtmlInputRadioButton.cs: Added DefaultValue attributes.
	* HtmlInputText.cs: Added DefaultValue attributes. Added method 
	RenderAttributes in 1.1 profile.
	* HtmlTable.cs: Fix DefaultValue to "".
	* HtmlTextArea.cs: Added DefaultValue attributes.

2005-07-12  Sebastien Pouliot  <sebastien@ximian.com> 

	* HtmlTableCell.cs: Added DefaultValue attributes.
	* HtmlTable.cs: Added DefaultValue and ParseChildren attributes.
	* HtmlTableRowCollection.cs: Reworked collection to share data with
	HtmlTable.Controls.
	* HtmlTableCellCollection.cs: Reworked collection to share data with
	HtmlTableRow.Controls.
	* HtmlTableRow.cs: Added DefaultValue and ParseChildren attributes.

2005-07-09  Sebastien Pouliot  <sebastien@ximian.com> 

	* HtmlTableRowCollection.cs: Fixed property name to IsReadOnly.

2005-07-08  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* HtmlTextArea.cs: Use CultureInfo.InvariantCulture in ToString ().

2005-07-08  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlContainerControl.cs: Fixed removal of attribute/viewstate for
	"innerhtml".
	* HtmlTextArea.cs: New implementation.

2005-07-07  Jackson Harper  <jackson@ximian.com>

	* HtmlInputImage.cs: New implementation.

2005-07-07  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlAnchor.cs: protected RaisePostBackEvent is in 2.0 only.
	* HtmlInputControl.cs: New implementation.
	* HtmlInputRadioButton.cs: New implementation.
	* HtmlInputText.cs: New implementation.

2005-07-07  Jackson Harper  <jackson@ximian.com>

	* HtmlInputHidden.cs: New implementation.

2005-07-07  Jackson Harper  <jackson@ximian.com>

	* HtmlAnchor.cs: Call base OnPreRender from override.

2005-07-07  Jackson Harper  <jackson@ximian.com>

	* HtmlInputButton.cs: New implementation.

2005-07-07  Dick Porter  <dick@ximian.com>

	* HtmlImage.cs: New implementation

2005-07-07  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlAnchor.cs: Fixed to remove attributes properly.
	* HtmlTable.cs: New implementation.
	* HtmlTableCell.cs: New implementation.
	* HtmlTableCellCollection.cs: New implementation.
	* HtmlTableRow.cs: New implementation.
	* HtmlTableRowCollection.cs: New implementation.

2005-07-06  Jackson Harper  <jackson@ximian.com>

	* HtmlButton.cs: New implementation.

2005-07-06  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlAnchor.cs: New implementation.

2005-06-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTableCell.cs:
	* HtmlControl.cs: updates for 1.1 SP1.

2005-05-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputFile.cs: fixed typo in the setter for MaxLength. Closes bug
	number 74989.

2005-05-06  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlHead.cs: Fix warning.

2005-04-22  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlForm.cs: Use the new WriteSubmitStatements method from
	Page.ClientScript.

2005-03-11  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlInputButton.cs, HtmlAnchor.cs, HtmlButton.cs: Don't use
	Page.GetPostBackClientEvent since it is deprecated in 2.0.

2005-02-25  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlForm.cs: Register the form in the page, so the page knows
	which is the main form.

2005-02-18  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlHead.cs: Method name fix.

2005-01-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: submitStatements holds Hashtables.

2004-12-20  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlHead.cs: Implemented.
	* HtmlHeadBuilder.cs: Implemented.
	* HtmlTitle.cs: Implemented.

2004-12-15 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: MakeRelative() can be null. Thanks to Denis Gervaille.

2004-11-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: fixed the Action property when running a different
	page than the one requested (Transfer). Closes bug #69318.

2004-11-26  Lluis Sanchez Gual <lluis@novell.com>

	* HtmlForm.cs: Add submit statements from the new Page.ClientScript
	property.

2004-06-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: disabled smartnavigation as we have no scripts to support
	it and failed when the browser was IE.

2004-05-14  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: default value for Enctype is "".
	* HtmlInputFile.cs: if no one set the encoding type for the HtmlForm,
	we set it to "multipart/form-data". Fixes bug #58359.

2004-01-15  Alon Gazit <along@mainsoft.com>
	* HtmlForm.cs: The property name always return the value of the
	property UniqueID.

2003-12-28  Alon Gazit <along@mainsoft.com>
	* HtmlSelect.cs: fix typo in LoadPostData().

2003-12-29  Alon Gazit <along@mainsoft.com>
	* HtmlInputButton.cs: update the implementation of RenderAttributes().
	Change the if statement that determines if the onclick script is
	rendered.  

2003-12-28  Alon Gazit <along@mainsoft.com>
	* HtmlSelect.cs: add parentheses to if statement. 
	Currently the else statement refers to the inner if statement. 

2003-12-28  Alon Gazit <along@mainsoft.com>
	* HtmlSelect.cs: fix upper bound of for statement.

2003-12-19  Jackson Harper <jackson@ximian.com>

	* HtmlInputFile.cs: Do not set value when loading post data.
	
2003-12-14  Alon Gazit <along@mainsoft.com>
	* HtmlInputButton.cs: The problem was in RenderAttributes().
	Before adding the script to the HTML, the number of Validators should 
	be checked. fixes bug #52158.

2003-12-07  Alon Gazit <along@mainsoft.com>
	* HtmlTableCell.cs: fixing a typo in NoWrap property. 

2003-12-04  Jackson Harper <jackson@ximian.com>

	* HtmlInputRadioButton.cs: Lookup name in postadata and compare to
	value. This is because radio button groups are created by setting
	the name to the same value with each button, then on postback the
	value of the name is the id of the selected radio button. 
	
2003-12-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlContainerControl.cs: encode/decode InnerText. Fixes bug #51653.

2003-12-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlSelect.cs: with the new LosFormatter, we get array types right, so
	remove the code used to workaround that.

2003-12-01  Jackson Harper <jackson@ximian.com>

	* HtmlControl.cs: Fix disabled property. Patch by Alon Gazit
	<along@mainsoft.com>.
	
2003-11-25  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlSelect.cs: don't add items without data. Patch by Alon Gazit
	<along@mainsoft.com>. Fixes bug #51377.

2003-11-24  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputRadioButton.cs: initialize event indexer. Patch by Alon Gazit
	<along@mainsoft.com>.

2003-10-29 Jackson Harper <jackson@ximian.com>

	* HtmlControl.cs: Make disabled an attribute of the control so it
	is rendered. This is a slightly modifed version of a patch
	by Yaron Shkop. Fixes bug #50160.
	
2003-10-16  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlTextArea.cs: fixed infinite recursion.

2003-10-13  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: render the onsubmit attribute.

2003-08-26  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlGenericControl.cs: ConstructorNeedsTag defaults to false so we
	need to pass true here. Fixes bug #47918.

2003-07-17  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* HtmlContainerControl.cs: Added attributes
	* HtmlControl.cs: Added attributes
	* HtmlInputControl.cs: Fixed public signature
	* HtmlInputRadioButton.cs: Fixed public signature
	* HtmlSelect.cs: Added missing attribute
	* HtmlTable.cs: Added missing attribute

2003-06-20  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlSelect.cs: fixed bug #44894.

2003-04-30  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlImage.cs:
	* HtmlInputControl.cs:
	* HtmlSelect.cs: added control builder attribute.

	* HtmlSelectBuilder.cs: builder for HtmlSelect.

	* HtmlControlBuilder.cs: common builder for all HtmlControls.

2003-01-29  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlControl.cs: _tagName is now internal.
	* HtmlGenericControl.cs: use the field in HtmlControl to keep the tag
	name.

2003-01-17  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* System.Web.UI.HtmlControls/HtmlForm.cs: render 'action' attribute.

2003-01-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputButton.cs: fixed bug #35677.

2003-01-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputControl.cs: fixed bug #35673.

2003-01-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputText.cs: fixed bug #35670.

2002-11-12  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlSelect.cs: fixed LoadViewstate.

2002-11-07  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlButton.cs: make it do a POST if the button has any ServerClick
	events.

2002-09-23  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlAnchor.cs:
	* HtmlButton.cs:
	* HtmlContainerControl.cs:
	* HtmlControl.cs:
	* HtmlForm.cs:
	* HtmlGenericControl.cs:
	* HtmlImage.cs:
	* HtmlInputButton.cs:
	* HtmlInputCheckBox.cs:
	* HtmlInputControl.cs:
	* HtmlInputFile.cs:
	* HtmlInputHidden.cs:
	* HtmlInputImage.cs:
	* HtmlInputRadioButton.cs:
	* HtmlInputText.cs:
	* HtmlSelect.cs:
	* HtmlTable.cs:
	* HtmlTableCell.cs:
	* HtmlTableRow.cs:
	* HtmlTextArea.cs: added almost all missing attributes.

2002-07-20  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlControl.cs: the attributes must use ViewState as its StateBag,
	if not style values are lost between postbacks.

2002-07-17  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlAnchor.cs:
	* HtmlButton.cs:
	* HtmlInputButton.cs:
	* HtmlInputCheckBox.cs:
	* HtmlInputHidden.cs:
	* HtmlInputImage.cs:
	* HtmlInputText.cs:
	* HtmlTextArea.cs: Initialize EventHandlerList indexer.

	* HtmlContainerControl.cs: almost rewritten to use a LiteralControl
	instead of maintaining some flags and strings. Implemented
	LoadViewState.

	* HtmlControl.cs: fixed constructor and added ViewStateIgnoreCase.

	* HtmlSelect.cs: fixed TrackViewState, SaveViewState, SelectedIndices
	and Value.

2002-07-12  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlGenericControl.cs: fixed TagName signature and get/set.
	* HtmlInputImage.cs: added attribute and fixed signature of ServerClick.
	* HtmlInputText.cs: added attribute.

2002-07-05  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: don't render action attribute.

2002-07-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlContainerControl.cs: 
	(CreateControlCollection): added. All containers must have a non-empty
	control collection.

2002-06-30  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* System.Web.UI.HtmlControls/HtmlAnchor.cs: 
	* System.Web.UI.HtmlControls/HtmlButton.cs: 
	* System.Web.UI.HtmlControls/HtmlControl.cs: 
	* System.Web.UI.HtmlControls/HtmlForm.cs: 
	* System.Web.UI.HtmlControls/HtmlGenericControl.cs: 
	* System.Web.UI.HtmlControls/HtmlInputButton.cs: 
	* System.Web.UI.HtmlControls/HtmlInputCheckBox.cs: 
	* System.Web.UI.HtmlControls/HtmlInputControl.cs: 
	* System.Web.UI.HtmlControls/HtmlInputFile.cs: 
	* System.Web.UI.HtmlControls/HtmlInputHidden.cs: 
	* System.Web.UI.HtmlControls/HtmlInputImage.cs: 
	* System.Web.UI.HtmlControls/HtmlInputRadioButton.cs: 
	* System.Web.UI.HtmlControls/HtmlInputText.cs: 
	* System.Web.UI.HtmlControls/HtmlSelect.cs: 
	* System.Web.UI.HtmlControls/HtmlTable.cs: 
	* System.Web.UI.HtmlControls/HtmlTableCell.cs: 
	* System.Web.UI.HtmlControls/HtmlTableRow.cs: 
	* System.Web.UI.HtmlControls/HtmlTextArea.cs: 

	Fixes based on class status page:
	
		- Add attributes (DefaultEvent, ParseChildren).
		- Fix declarations.
		- Explicitly implement some interfaces (IPostBackDataHandler
		and IPostBackEventHandler).
		- Implemented some missing methods.

2002-06-24  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs:
	(RenderChildren): use OnFormRender and OnFormPostRender.

2002-06-09  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlSelect.cs:
	(RenderAttributes): new -> override and fixes stack overflow.
	(RenderChildren): only 1 option can be selected at any given time
	except when Multiple property is true.
	(Multiple): the attribute value is either "true" or "false", not 
	"multiple".

	* HtmlTable.cs:
	(Add):
	(AddAt): allow HtmlTableRow as children, not HtmlTableCell.

	* HtmlTableCell.cs:
	(RenderEndTag): new -> override.

	* HtmlTableRow.cs:
	(RenderChildren): fixed another stack overflow.
	(RenderEndTag): new -> override.

	* HtmlTextArea.cs:
	(RenderAttributes): new -> override.


2002-06-07  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlInputHidden.cs: fixed constructor.

	* HtmlInputRadioButton.cs:
	(RenderAttributes): fixed stack overflow.

	(Name):
	(RenderedName): new -> override.

	(Value): new property. 

	* HtmlInputText.cs:
	(RenderAttributes): fixed the same kind of stack overflow and make
	string comparison case insensitive.

2002-06-07  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlForm.cs: fixed name of Enctype property and render enctype
	enctype attribute.

	* HtmlInputControl.cs: tag type is "input", not "type".

2002-06-06  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlControl.cs: Render contents moved to new RenderBeginTag method,
	defined in MS docs. 
	
	* HtmlForm.cs: Render output when no IE browser.

	* HtmlInputButton.cs: added constructor without arguments. Xsp used it, 
	though now it always use the other .ctor.
	
	* HtmlInputControl.cs: cosmetic changes and implemented set_Name.

2002-06-05  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlButton.cs: RenderAttributes is an override, not new.

	* HtmlContainerControl.cs: use the new Render method in HtmlControl.

	* HtmlControl.cs: added Render method to render the tag and its
	attributes. Works for container and non-containers.

	* HtmlImage.cs: RenderAttributes don't need to be new. Implemented
	Height property.
	
2002-06-05  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlContainerControl.cs: some formatting and use HttpUtility.Encode
	instead of Page.Server to encode InnerText.

2002-06-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HtmlAnchor.cs:
	(RenderAttributes): new -> override and fixed little bug that made
	it cause an stack overflow.

	* HtmlContainerControl.cs: reformatted and added tag and attributes 
	rendering.

	* HtmlGenericControl.cs: removed TagName, which is already in 
	HtmlControl.

	* HtmlTable.cs:
	(RenderEndTag): new -> override.

2002-06-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* System.Web.UI.HtmlControls/HtmlForm.cs:
	(RenderAttributes): changed new by override.
	(Name): allow setting the property.

2002-05-10  Duncan Mak  <duncan@ximian.com>

	* HtmlTableCellCollection.cs (this): Updated the indexer to return
	the right type, HtmlTableCell instead of HtmlTableRow. 

	* HtmlInputImage.cs (OnServerClick): Commented out parts that
	won't compile.

	* HtmlForm.cs (RenderAttributes): 
	(RenderChildren): Commented out code that doesn't compile. 

2002-05-07  Duncan Mak  <duncan@ximian.com>

	* HtmlSelect.cs (TrackViewState): Added 'new' keyword to avoid
	clashing with the method defined in the parent class.
	(OnDataBinding): Added missing casts.

	* HtmlForm.cs (Render): Fixed call too SetAttribute, need to cast
	'this' to IAttributeAccessor before calling interface method.
	Also renamed some calls to reflect changes in the API.

	* HtmlControl.cs (WriteOnClickAttribute): Made it not static and
	fixed a typo.

2001-09-03  Leen Toelen  <toelen@hotmail.com>

        * HtmlAnchor.cs: Initial implementation.
        * HtmlTextArea.cs: Initial implementation.

2001-08-22  Bob Smith  <bob@thestuff.net>

         * HtmlContainerControl.cs: Initial implementation.
         * HtmlControl.cs: Initial implementation.
         * HtmlGenericControl.cs: Initial implementation.
